import java.awt.*;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * Your task this week is to count the number of islands
 * from a text file that has been processed into a 2D array.
 * The text files will contain either 0s or 1s, 1s being land, 0s being water.
 * Consider this an extension from last week's assignment, with a few tweaks.
 * Adjacent nodes within islands now include the diagonal neighbors as well.
 *
 * Using this framework, fill out countIslands(). You may need to use 
 * a private helper method: consider what algorithm is best suited for this task
 * given the inputs you have to work with.
 */
public class IslandCounter {

    // Direction vectors, going in all 8 directions
    public static final int[] ROW_OFFSET = {-1, -1, -1, 0, 0, 0, 1, 1, 1};
    public static final int[] COL_OFFSET = { -1, 0, 1, -1, 0, 1, -1, 0, 1,};

    // Node for a island
    static class LandNode {
        List<LandNode> adjacencyList;
        Point coords;

        public LandNode() {
            adjacencyList = new ArrayList<>();
        }

        // Adds an undirected path between this node and another node
        public void addNeighbor(LandNode node) {
            this.adjacencyList.add(node);
            node.adjacencyList.add(this);
        }
    }

    private final String[][] islandArray;
    private final HashMap<Point, LandNode> nodes;

    public IslandCounter(String islandFile) {
        nodes = new HashMap<>();
        BufferedReader br = null;
        try {
            br = new BufferedReader(new FileReader(islandFile));
            String[] header = br.readLine().split(" ");
            this.islandArray = new String[Integer.parseInt(header[0])][Integer.parseInt(header[1])];
            buildIslandArray(br);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * Builds an island array from a file
     */
    private void buildIslandArray(BufferedReader br) {
        String line;
        int row = 0;
        try {
            while ((line = br.readLine()) != null) {
                String[] lineItems = line.split(" ");
                System.arraycopy(lineItems, 0, islandArray[row], 0, lineItems.length);
                row++;
            }
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * Gets the map of nodes
     * @return hashmap of points to their respective nodes
     */
    public HashMap<Point, LandNode> getNodes() {
        return nodes;
    }

    public int countIslands() {
        // TODO
        return 0;
    }
}
